	/* HTMLϊ */

#include <stdio.h>
#include <dos.h>

#define uchar unsigned char
#define IsKanji(c)	((c)>=0x80 && (c)<0xa0 || (c)>=0xe0 && (c)<=0xfc)
#define IsKana(c,cc)	((c)==0x82  && ((cc)>=0x9f || (cc)<=0xf1) )


void fferror(char *s){				/* G[ */
	fputs(s,stderr);
	fputs("I[vł܂\n",stderr);
	exit(-1);
}

void fnameset(char *buf,uchar *s,char *typ){	/* pXRs[AgqύX */
	int i;
	for(i=0;i<120;i++){
		if(*s=='.' || *s<=0x20) break;
		*buf++=*s++;
	}
	strcpy(buf,typ);
}

long dos_filesize(char *path){			/* t@CTCY */
	static struct find_t di;
	if(_dos_findfirst(path,0x3f,&di)) return 0;
	return di.size;
}

unsigned d_fontsize(long filesize){		/* HTMLtHgTCY̌ */
	unsigned i;
	for(i=100;i<=250;i++)
		if( filesize > (44000000L / (i*i)) ) break;
	return  i;
}
	/* tHgTCY̖ڈ
		(4400/filesize ) ~100(p[Zg)
			1703kb	    161% 
	*/


	uchar   kbuf[1024];
	char *kanastr={"ȈȉFF]]vX׎u{󐢐]mxsÓVBo`ގzHTgkϔҕzՕقؕەݔĕRR^^ǗXCaa׌b"};
		/* t */


main(int argc, char *argv[]){	/*yCz*/
	char *fname;
	static char outname[128],ininame[128];
	FILE *fp, *fo, *fi;

	char *kanamoji, *k,
	     *fontfamily;
	unsigned fontsize;

	int  kanaflg=0;			/* O=Ђ炪 ̂Ƃ1 */
	uchar c, cc; 
	int n=1;

	if(argv[n][0]=='-'){ 
		fontfamily=argv[n]+1;
		n++;
	}
	fname=argv[n];				/* t@CAtxt htm ini */
	fnameset(outname,fname,".htm");
	fnameset(ininame,argv[0],".ini");

	kanamoji=kanastr;
	if((fi=fopen(ininame,"rt"))!=0){	/* t */
		fgets(kbuf,1020,fi);
		kanamoji=kbuf;
		fclose(fi);
	}

	if((fo=fopen(outname,"wt"))==0) fferror(outname);
	if((fp=fopen(fname,"rt"))==0) fferror(fname);

	if((fontsize=d_fontsize(dos_filesize(fname)))==0) fferror(fname);	/* t@CTCY fontsize */

						/* HTMLwb_o */
	fputs("<html>\n<head>\n<title>",fo);
	fputs("</title>\n<style type=\"text/css\"><!-- body{}\n",fo);
	fputs("div{ writing-mode:tb-rl; line-height:106%; font-size:",fo);
	fprintf(fo,"%d",fontsize);
	fputs("%; font-family:",fo);
	if(n>1){
		fputs("'",fo); fputs(fontfamily,fo); fputs("'",fo);
	}
	fputs("'ARM','HG','DF','HG-PRO'; }\n",fo);
	fputs("i{font-style:normal; font-size:70%; vertical-align:super;} --></style>\n",fo);
	fputs("</head>\n<body>\n<div>\n",fo);

	for(;;){
		if(feof(fp)) break;
		c=fgetc(fp);
		if(IsKanji(c)){
			cc=fgetc(fp);
			if(IsKana(c,cc)){
				if(kanaflg==0) fputs("<i>",fo);
				kanaflg=1;
				k=kanamoji+(cc-0x9f)*2;
				fputc(*k++,fo);
				fputc(*k,fo);
			}else{
				if(kanaflg==1) fputs("</i>",fo);
				kanaflg=0;
				fputc(c,fo);
				fputc(cc,fo);
			}
		}else{
			if(c>0x20){ 
				if(kanaflg==1) fputs("</i>",fo);
				kanaflg=0;
			}
			if(c=='\n'){ 
				if(kanaflg==1) fputs("</i>",fo);
				kanaflg=0;
				fputs("<br>\n",fo);
			}else if(c>=0x20 && c<=0xdf || c==9){
				fputc(c,fo);
			}
		}
	}

	fputs("\n</div>\n</body></html>\n",fo);

	fclose(fp);
	fclose(fo);
	exit(0);
}
